<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <title>Constructors</title>
</head>

<body>
  <div class="wrap"></div>
  <script>
    /*
  
      Задание:
  
      Написать функцию конструктор, которая будет иметь приватные и публичные свойства.
      Публичные методы должны вызывать приватные.
  
      Рассмотрим на примере планеты:
  
        - На вход принимаются параметр Имя планеты.
  
        Создается новый обьект, который имеет публичные методы и свойства:
        - name (передается через конструктор)
        - population ( randomPopulation());
        - rotatePlanet(){
          let randomNumber = Math.floor(Math.random() * (1000 - 1 + 1)) + 1;
          if ( (randomNumber % 2) == 0) {
            growPopulation();
          } else {
            Cataclysm();
          }
        }
  
        Приватное свойство:
        populationMultiplyRate - случайное число от 1 до 10;
  
        Приватные методы
        randomPopulation -> Возвращает случайное целое число от 1.000 до 10.000
        growPopulation() {
          функция которая берет приватное свойство populationMultiplyRate
          которое равняется случайному числу от 1 до 10 и умножает его на 100.
          Дальше, число которое вышло добавляет к популяции и выводит в консоль сообщение,
          что за один цикл прибавилось столько населения на планете .
        }
        Cataclysm(){
          Рандомим число от 1 до 10 и умножаем его на 10000;
          То число которое получили, отнимаем от популяции.
          В консоль выводим сообщение - от катаклизма погибло Х человек на планете.
        }
  
    */
    function Galactick(name) {

      this.name = name;
      this.population = randomPopulation(1000, 10000);
      this.rotatePlanet = function () {
        let randomNumber = Math.floor(Math.random() * (1000 - 1 + 1)) + 1;
        if ((randomNumber % 2) == 0) {
          growPopulation.apply(this);
        } else {
          Cataclysm();
        }
      }

      function randomPopulation(min, max) {
        var min = Math.ceil(min);
        var max = Math.floor(max);
        return Math.floor(Math.random() * (max - min + 1)) + min;
      };

      const populationMultiplyRate = randomPopulation(1, 10);

      function growPopulation() {
        console.log( this );
        this.population += populationMultiplyRate * 1000;
        console.log("за один цикл прибавилось " + populationMultiplyRate * 1000   + "  население на планете = " + (this.population) );
      }
      const Cataclysm = () => {
        this.population -= populationMultiplyRate * 1000;  
        console.log("от катаклизма погибло " + (populationMultiplyRate * 1000 ) + " человек на планете. " + this.population);
      } 


    }
    let Earth = new Galactick('Earth');
    
        Earth.rotatePlanet();
        Earth.rotatePlanet();
        Earth.rotatePlanet();
        Earth.rotatePlanet();
        Earth.rotatePlanet();
        Earth.rotatePlanet();
        Earth.rotatePlanet();



  </script>
</body>

</html>